<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright  2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: forum_icons_admin.php
| Version: 1.00
| Author: Yodix (www.on-deck.eu)
| Release Date: 31/12/2011
| Last Update Date: --/--/----
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
require_once "../../maincore.php";
require_once THEMES."templates/admin_header.php";

include INFUSIONS."forum_icons/infusion_db.php";
include INCLUDES."infusions_include.php";
require_once INCLUDES."photo_functions_include.php";

if (!checkrights("FI") || !defined("iAUTH") || $_GET['aid'] != iAUTH) { redirect("../index.php"); }

if (file_exists(INFUSIONS."forum_icons/locale/".$settings['locale'].".php")) {
	include INFUSIONS."forum_icons/locale/".$settings['locale'].".php";
} else {
	include INFUSIONS."forum_icons/locale/English.php";
}

$nav = "<table cellpadding='0' cellspacing='0' class='tbl-border' align='center' style='width:300px; margin-bottom:20px; text-align:center;'>\n<tr>\n";
$nav .= "<td class='".(!isset($_GET['page']) || $_GET['page'] != "settings" ? "tbl2" : "tbl1")."'><a href='".FUSION_SELF.$aidlink."'>".$locale['fi_050']."</a></td>\n";
$nav .= "<td class='".(isset($_GET['page']) && $_GET['page'] == "settings" ? "tbl2" : "tbl1")."'><a href='".FUSION_SELF.$aidlink."&amp;page=settings'>".$locale['fi_051']."</a></td>\n";
$nav .= "</tr>\n</table>\n";

if (!isset($_GET['page']) || $_GET['page'] != "settings") {

$fi_settings = get_settings("forum_icons");

if (isset($_GET['status']) && !isset($message)) {
	if ($_GET['status'] == "icon_added") {
		$message = $locale['fi_010'];
	} elseif ($_GET['status'] == "icon_add_error") {
		$message = $locale['fi_010a'];
	} elseif ($_GET['status'] == "icon_deleted") {
		$message = $locale['fi_011'];
	} elseif ($_GET['status'] == "icon_delete_error") {
		$message = $locale['fi_011a'];
	} elseif ($_GET['status'] == "icon_error_1") {
		$message = $locale['fi_012'].$locale['fi_012a'];
	} elseif ($_GET['status'] == "icon_error_2") {
		$message = $locale['fi_012'].sprintf($locale['fi_012b'], $fi_settings['icon_max_b']);
	} elseif ($_GET['status'] == "icon_error_3") {
		$message = $locale['fi_012'].$locale['fi_012c'];
	} elseif ($_GET['status'] == "icon_error_4") {
		$message = $locale['fi_012'].sprintf($locale['fi_012d'], $fi_settings['icon_max_w'], $fi_settings['icon_max_h']);
	} elseif ($_GET['status'] == "forum_icon_exist") {
		$message = $locale['fi_013'];
	} elseif ($_GET['status'] == "forum_not_exist") {
		$message = $locale['fi_014'];
	}
	if ($message) {	echo "<div id='close-message'><div class='admin-message'>".$message."</div></div>\n"; }
}

if ((isset($_GET['action']) && $_GET['action'] == "delete") && (isset($_GET['icon_id']) && isnum($_GET['icon_id']))) {
	$result = dbquery("SELECT forum_icon_file FROM ".DB_FORUM_ICONS." WHERE forum_icon_id='".$_GET['icon_id']."'");
	$data = dbarray($result);
	@unlink(INFUSIONS."forum_icons/icons/".$data['forum_icon_file']);
	$result2 = dbquery("DELETE FROM ".DB_FORUM_ICONS." WHERE forum_icon_id='".$_GET['icon_id']."'");
	redirect(FUSION_SELF.$aidlink."&status=icon_deleted");
} else {
	if (isset($_POST['save_cat'])) {
		$forum_name = stripinput($_POST['forum_name']);
		$forum_id = dbarray(dbquery("SELECT forum_id FROM ".DB_FORUMS." WHERE forum_name='".$forum_name."'"));
		$icon_forum = $forum_id['forum_id'];
		if (!empty($_FILES['icon_pic_file']['name']) && is_uploaded_file($_FILES['icon_pic_file']['tmp_name'])) {
			$icon_types = array(".gif",".jpg",".jpeg",".png");
			$icon_pic = $_FILES['icon_pic_file'];
			$icon_name = stripfilename(strtolower(substr($icon_pic['name'], 0, strrpos($icon_pic['name'], "."))));
			$icon_ext = strtolower(strrchr($icon_pic['name'],"."));
			$icon_dest = INFUSIONS."forum_icons/icons/";
			if (!preg_match("/^[-0-9A-Z_\[\]]+$/i", $icon_name)) {
				redirect(FUSION_SELF.$aidlink."&status=icon_error_1");
			} elseif ($icon_pic['size'] > $fi_settings['icon_max_b']){
				redirect(FUSION_SELF.$aidlink."&status=icon_error_2");
			} elseif (!in_array($icon_ext, $icon_types)) {
				redirect(FUSION_SELF.$aidlink."&status=icon_error_3");
			} else {
				$icon_file = image_exists($icon_dest, $icon_name.$icon_ext);
				move_uploaded_file($icon_pic['tmp_name'], $icon_dest.$icon_file);
				chmod($icon_dest.$icon_file, 0644);
				$imagefile = @getimagesize($icon_dest.$icon_file);
				if (!verify_image($icon_dest.$icon_file)) {
					redirect(FUSION_SELF.$aidlink."&status=icon_error_3");
					unlink($icon_dest.$icon_file);
				} elseif ($imagefile[0] > $fi_settings['icon_max_w'] || $imagefile[1] > $fi_settings['icon_max_h']) {
					redirect(FUSION_SELF.$aidlink."&status=icon_error_4");
					unlink($icon_dest.$icon_file);
				} else {
					$icon_icon = $icon_file;
				}
			}
		}
		$forum_icons = dbcount("(forum_icon_forum)", DB_FORUM_ICONS, "forum_icon_forum='".$icon_forum."'");
		if ($forum_icons == "0") {
			$result = dbquery("INSERT INTO ".DB_FORUM_ICONS." (forum_icon_forum, forum_icon_file) VALUES('".$icon_forum."', '".$icon_icon."')");
			redirect(FUSION_SELF.$aidlink."&status=icon_added");
		} else {
			redirect(FUSION_SELF.$aidlink."&status=forum_icon_exist");
		}
	}

	opentable($locale['fi_000']);
	echo $nav;
	echo "<form name='addcat' method='post' enctype='multipart/form-data' action='".FUSION_SELF.$aidlink."'>\n";
	echo "<table cellpadding='0' cellspacing='0' width='400' class='center'>\n<tr>\n";
	echo "<td width='1%' class='tbl' style='white-space:nowrap'>".$locale['fi_020']."</td>\n";
	echo "<td class='tbl'><input type='text' name='forum_name' value='' class='textbox' style='width:200px;' /></td>\n";
	echo "</tr>\n<tr>\n";
	echo "<td width='1%' class='tbl' style='white-space:nowrap'>".$locale['fi_021']."</td>\n";
	echo "<td class='tbl'><label><input type='file' name='icon_pic_file' class='textbox' style='width:250px;' /><br />\n";
	echo "<span class='small2'>".sprintf($locale['fi_030'], parsebytesize($fi_settings['icon_max_b']), $fi_settings['icon_max_w'], $fi_settings['icon_max_h'])."</span></label></td>\n";
	echo "</tr>\n<tr>\n";
	echo "<td align='center' colspan='2' class='tbl'>\n";
	echo "<input type='submit' name='save_cat' value='".$locale['fi_022']."' class='button' /></td>\n";
	echo "</tr>\n</table>\n</form>\n";
	closetable();

	opentable($locale['fi_001']);
	echo "<table width='400' cellspacing='1' cellpadding='0' class='tbl-border center'>\n";
	$result = dbquery("SELECT forum_icon_id, forum_icon_forum, forum_icon_file FROM ".DB_FORUM_ICONS." ORDER BY forum_icon_id");
	if (dbrows($result) != 0) {
		$i = 0;
		echo "<tr>\n";
		echo "<td class='tbl2'>".$locale['fi_040']."</td>\n";
		echo "<td align='center' width='1%' class='tbl2' style='white-space:nowrap'>".$locale['fi_041']."</td>\n";
		echo "<td align='center' width='1%' class='tbl2' style='white-space:nowrap'>".$locale['fi_042']."</td>\n";
		echo "</tr>\n";
		while ($data = dbarray($result)) {
			$cell_color = ($i % 2 == 0 ? "tbl1" : "tbl2");
			echo "<tr>\n";
			echo "<td class='".$cell_color."'><img src='".INFUSIONS."forum_icons/icons/".$data['forum_icon_file']."' />\n";
			$forum_data = dbarray(dbquery("SELECT forum_name FROM ".DB_FORUMS." WHERE forum_id='".$data['forum_icon_forum']."'"));
			echo "</td>\n<td align='center' width='1%' class='$cell_color' style='white-space:nowrap'>".$forum_data['forum_name']."</td>\n";
			echo "<td align='center' width='1%' class='$cell_color' style='white-space:nowrap'><a href='".FUSION_SELF.$aidlink."&amp;action=delete&amp;icon_id=".$data['forum_icon_id']."' onclick=\"return confirm('".$locale['fi_046']."');\">".$locale['fi_045']."</a></td>\n";
			echo "</tr>\n";
			$i++;
		}
		echo "</table>\n";
	} else {
		echo "<tr><td align='center' class='tbl1'>".$locale['fi_043']."</td></tr>\n</table>\n";
	}
	closetable();
}

} else {
	if (isset($_GET['status']) && !isset($message)) {
		if ($_GET['status'] == "settings_updated") {
			$message = $locale['fi_015'];
		} elseif ($_GET['status'] == "settings_update_error") {
			$message = $locale['fi_015a'];
		}
		if ($message) {	echo "<div id='close-message'><div class='admin-message'>".$message."</div></div>\n"; }
	}
	if (isset($_POST['save_settings'])) {
		if (isset($_POST['icon_max_w']) && isnum($_POST['icon_max_w'])) {
			$setting = set_setting("icon_max_w", $_POST['icon_max_w'], "forum_icons");
		} else {
			redirect(FUSION_SELF.$aidlink."&amp;page=settings&amp;status=settings_update_error");
		}
		if (isset($_POST['icon_max_h']) && isnum($_POST['icon_max_h'])) {
			$setting = set_setting("icon_max_h", $_POST['icon_max_h'], "forum_icons");
		} else {
			redirect(FUSION_SELF.$aidlink."&amp;page=settings&amp;status=settings_update_error");
		}
		if (isset($_POST['icon_max_b']) && isnum($_POST['icon_max_b'])) {
			$setting = set_setting("icon_max_b", $_POST['icon_max_b'], "forum_icons");
		} else {
			redirect(FUSION_SELF.$aidlink."&amp;page=settings&amp;status=settings_update_error");
		}
		redirect(FUSION_SELF.$aidlink."&amp;page=settings&amp;status=settings_updated");
	}

	$fi_settings = get_settings("forum_icons");
	opentable($locale['fi_002']);
	echo $nav;
	echo "<form method='post' action='".FUSION_SELF.$aidlink."&amp;page=settings'>\n";
	echo "<table cellpadding='0' cellspacing='0' align='center' class='tbl-border' style='width:300px; margin-top:20px;'>\n";
	echo "<tr>\n";
	echo "<td class='tbl1'>".$locale['fi_060']."<br /><sup>".$locale['fi_061']."</sup></td>\n";
	echo "<td class='tbl1'><input type='text' name='icon_max_w' value='".$fi_settings['icon_max_w']."' maxlength='3' class='textbox' style='width:40px;' /> x\n";
	echo "<input type='text' name='icon_max_h' value='".$fi_settings['icon_max_h']."' maxlength='3' class='textbox' style='width:40px;' /></td>\n";
	echo "</tr>\n<tr>\n";
	echo "<td class='tbl1'>".$locale['fi_062']."</td>\n";
	echo "<td class='tbl1'><input type='text' name='icon_max_b' class='textbox' value='".$fi_settings['icon_max_b']."' /></td>\n";
	echo "</tr>\n<tr>\n";
	echo "<td class='tbl1' colspan='2' style='text-align:center;'><input type='submit' name='save_settings' value='".$locale['fi_063']."' class='button' /></td>\n";
	echo "</tr>\n</table>\n";
	echo "</form>\n";
	closetable();
}

require_once THEMES."templates/footer.php";
?>